
BUP_ERROR BUP_Delete(BACKUP_DEVICE device,uchar *filename)

{
  int iVar1;
  BUP_ERROR BVar2;
  short sVar3;
  backup_stat stat;
  
  if (device != DEVICE_SERIAL) {
                    /* Stat device
                        */
    BVar2 = (*(code *)(DAT_06027bcc + 0x6027b96))(device,0,&stat);
    if (BVar2 != BUP_SUCCESS) {
      return BVar2;
    }
    sVar3 = SearchForSaveBlock((char *)filename,DEFAULT);
    if (sVar3 != 0) {
      DeleteFileByID();
      return BUP_SUCCESS;
    }
    return BUP_NOT_FOUND;
  }
  if ((*PTR_INTERNAL_METADATA_06027b30)->serial_connected == 0) {
    return BUP_NOT_CONNECTED;
  }
  iVar1 = (*(code *)(PTR_PTR_DAT_06027b34 + 0x6027b24))(filename);
  if (iVar1 == 0) {
    return BUP_SUCCESS;
  }
  if (iVar1 == 0x21) {
    return BUP_NOT_CONNECTED;
  }
  if (iVar1 == 0x23) {
    return BUP_WRITE_PROTECTED;
  }
  if (iVar1 == 0x24) {
    return BUP_NOT_FORMATTED;
  }
  if (iVar1 != 0x30) {
    if ((iVar1 != DAT_06027bc8) && (iVar1 != DAT_06027bca)) {
      return ~BUP_SUCCESS;
    }
    return BUP_NOT_CONNECTED;
  }
  return BUP_NOT_FOUND;
}


BUP_ERROR BUP_Dir(BACKUP_DEVICE device,uchar *filename,uint output_size,backup_file *file_metadata)

{
  int curr_read_offset;
  uint comment_byte;
  short sVar1;
  byte *outputBuffer;
  int iVar2;
  backup_file *output_file2;
  byte *backup_ram_start;
  uint bytes_written;
  dword *pdVar3;
  int block_offset_from_ram_start;
  BUP_ERROR i;
  dword *pdStack_44;
  backup_stat backup_stat;
  INTERNAL_METADATA **im;
  uchar *filename2;
  
  im = PTR_INTERNAL_METADATA_06027d48;
  filename2 = filename;
  if (device == DEVICE_SERIAL) {
    if ((*PTR_INTERNAL_METADATA_06027d48)->serial_connected == 0) {
      i = BUP_SUCCESS;
    }
    else {
      i = output_size & 0xffff;
      curr_read_offset = (*(code *)(PTR_LAB_06027d4c + 0x6027d1a))(filename,file_metadata,&i);
      if (curr_read_offset != 0) {
        if (curr_read_offset == PTR_DAT_06027d3c._0_2_) {
          i = -i;
        }
        else {
          i = BUP_SUCCESS;
        }
      }
    }
  }
  else {
    curr_read_offset = (*(code *)(DAT_06027d78 + 0x6027d5a))(device,0,&backup_stat);
    if (curr_read_offset == 0) {
      i = BUP_SUCCESS;
      comment_byte = SearchForSaveBlock((char *)filename2,SAVE_SEARCH);
      while ((comment_byte & 0xffff) != 0) {
        if (i < (output_size & 0xffff)) {
          bytes_written = 0;
          backup_ram_start = (*im)->backup_ram_start;
          block_offset_from_ram_start = (*im)->blockSize_in_bytes * (comment_byte & 0xffff);
                    /* Copy the filename */
          curr_read_offset = 8;
          do {
            iVar2 = curr_read_offset;
            outputBuffer = file_metadata[i].filename + bytes_written;
            bytes_written = bytes_written + 1;
            *outputBuffer = backup_ram_start[iVar2 + 1 + block_offset_from_ram_start];
            curr_read_offset = iVar2 + 2;
          } while (bytes_written < 0xb);
          file_metadata[i].filename[0xb] = 0;
                    /* Read the language */
          curr_read_offset = iVar2 + 4;
          file_metadata[i].language = backup_ram_start[iVar2 + 3 + block_offset_from_ram_start];
                    /* Read the comment */
          comment_byte = 0;
          do {
            file_metadata[i].comment[comment_byte] =
                 backup_ram_start[curr_read_offset + 1 + block_offset_from_ram_start];
            iVar2 = comment_byte + 1;
            comment_byte = comment_byte + 2;
            file_metadata[i].comment[iVar2] =
                 backup_ram_start[curr_read_offset + 3 + block_offset_from_ram_start];
            curr_read_offset = curr_read_offset + 4;
          } while (comment_byte < 10);
          file_metadata[i].comment[10] = 0;
                    /* Read the date */
          pdVar3 = &file_metadata[i].date;
          do {
            *(byte *)pdVar3 = backup_ram_start[curr_read_offset + 1 + block_offset_from_ram_start];
            *(byte *)((int)pdVar3 + 1) =
                 backup_ram_start[curr_read_offset + 3 + block_offset_from_ram_start];
            pdVar3 = (dword *)((int)pdVar3 + 2);
            curr_read_offset = curr_read_offset + 4;
          } while (pdVar3 < &file_metadata[i].datasize);
          pdVar3 = &file_metadata[i].datasize;
                    /* read the datasize
                        */
          pdStack_44 = &file_metadata[i].blocksize;
          do {
            *(byte *)pdVar3 = backup_ram_start[curr_read_offset + 1 + block_offset_from_ram_start];
            *(byte *)((int)pdVar3 + 1) =
                 backup_ram_start[curr_read_offset + 3 + block_offset_from_ram_start];
            pdVar3 = (dword *)((int)pdVar3 + 2);
            curr_read_offset = curr_read_offset + 4;
          } while (pdVar3 < pdStack_44);
          output_file2 = file_metadata + i;
                    /* Block Size = ((byte size + 29)/58) + 1 */
          sVar1 = (*(code *)(PTR_LAB_06027ed0 + 0x6027ea8))();
          *(short *)&output_file2->blocksize = sVar1 + 1;
        }
        i = i + BUP_NOT_CONNECTED;
        comment_byte = SearchForSaveBlock((char *)filename2,RESUME_SEARCH);
      }
      if ((output_size & 0xffff) < i) {
        i = -i;
      }
    }
    else {
      i = BUP_SUCCESS;
    }
  }
  return i;
}


BUP_ERROR BUP_Format(BACKUP_DEVICE device)

{
  byte *pbVar3;
  BUP_ERROR BVar1;
  byte *block;
  byte *pbVar2;
  byte *ram_addr;
  uint i;
  uint j;
  int k;
  dword block_sector___;
  byte *backup_ram_start;
  code *waitLoopFP;
  INTERNAL_METADATA **im;
  undefined4 onChipFlags__;
  byte backup_ram_str [20];
  byte powers_of_two [8];
  backup_stat device_stat;
  undefined *setOnChipFP;
  
  setOnChipFP = PTR_PTR_SetOnChipReg__06026830;
  waitLoopFP = (code *)(PTR_DAT_0602682c + 0x60267e4);
  im = (INTERNAL_METADATA **)(PTR_PTR_SetOnChipReg__06026830 + 0x14);
  if (device == DEVICE_SERIAL) {
    if ((*im)->serial_connected == 0) {
      BVar1 = BUP_NOT_CONNECTED;
    }
    else {
      k = (*(code *)(PTR_LAB_06026834 + 0x6026818))((int)(char)(*im)->serial_partition_number);
      if (k == 0) {
        BVar1 = BUP_SUCCESS;
      }
      else if (k == 0x21) {
        BVar1 = BUP_NOT_CONNECTED;
      }
      else if (k == 0x23) {
        BVar1 = BUP_WRITE_PROTECTED;
      }
      else {
        BVar1 = ~BUP_SUCCESS;
      }
    }
  }
  else {
    setupPowersOf2Struct(powers_of_two);
    InitBackupRamFormatString((char *)backup_ram_str);
    BVar1 = BUP_Stat(device,0,&device_stat);
    if ((BVar1 == BUP_SUCCESS) || (BVar1 == BUP_NOT_FORMATTED)) {
      for (i = 0; i < (*im)->totalBlocks; i = i + 1) {
        *(undefined *)((int)(*im)->sat_blocks + i) = 0;
                    /* TODO: what are we zeroing out here? Is fileID a pointer to BUP memory? Or is
                       it a  list of handles? */
      }
      if ((*im)->cart_format_flag_ == 1) {
        onChipFlags__ = *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_060268dc;
        (**(code **)setOnChipFP)(0xffffffff);
        if ((*im)->blockSize == (int)BLOCK_SIZE_0x200) {
          *(byte *)((int)(*im)->sat_blocks + 5) = powers_of_two[2];
        }
        else if ((*im)->blockSize == (int)BLOCK_SIZE_0x100) {
          *(byte *)((*im)->sat_blocks + 5) = powers_of_two[5];
        }
      }
                    /* Write the string "BackupRam Format" at the beginning of backup ram. There are
                       blocksize >> 4 of these 16 byte strings to start memory.  */
      backup_ram_start = (*im)->backup_ram_start;
      for (i = 0; i < (*im)->blockSize >> 4; i = i + 1) {
        j = 0;
        do {
          k = j + 1;
          backup_ram_start[(i * 0x10 + j) * 2 + 1] = backup_ram_str[j];
          j = j + 2;
          backup_ram_start[(i * 0x10 + k) * 2 + 1] = backup_ram_str[k];
        } while (j < 0x10);
      }
      if ((*im)->cart_format_flag_ == 1) {
        (*waitLoopFP)();
      }
      for (i = 2; i < (*im)->totalBlocks; i = i + 1) {
        block_sector___ = (*im)->blockSize_in_bytes;
        block = (*im)->backup_ram_start;
        for (j = 0; j < (*im)->blockSize; j = j + 1) {
          block[j * 2 + block_sector___ * i + 1] = 0;
        }
        if ((*im)->cart_format_flag_ == 1) {
          (*waitLoopFP)();
        }
      }
      for (i = 2; i < (*im)->totalBlocks; i = i + 1) {
        pbVar2 = (*im)->backup_ram_start;
        block_sector___ = (*im)->blockSize_in_bytes;
        for (j = 0; j < (*im)->blockSize; j = j + 1) {
          if (pbVar2[j * 2 + block_sector___ * i + 1] != 0) {
            pbVar3 = (byte *)((int)(*im)->sat_blocks + (i >> 3));
            *pbVar3 = *pbVar3 | powers_of_two[i & 7];
          }
        }
      }
      pbVar2 = (*im)->backup_ram_start;
      block_sector___ = (*im)->blockSize_in_bytes;
      for (i = 0; i < (*im)->blockSize; i = i + 1) {
        if (i < (*im)->totalBlocks >> 3) {
          pbVar2[i * 2 + block_sector___ + 1] = *(byte *)((int)(*im)->sat_blocks + i);
        }
        else {
          pbVar2[i * 2 + block_sector___ + 1] = 0;
        }
      }
      if ((*im)->cart_format_flag_ == 1) {
        (*waitLoopFP)();
      }
      for (i = 0; i < (*im)->totalBlocks >> 3; i = i + 1) {
        if (pbVar2[i * 2 + block_sector___ + 1] != *(byte *)((int)(*im)->sat_blocks + i)) {
          if ((*im)->cart_format_flag_ == 1) {
            (**(code **)setOnChipFP)(onChipFlags__);
          }
          return BUP_BROKEN;
        }
      }
      if ((*im)->cart_format_flag_ == 1) {
        (**(code **)setOnChipFP)(onChipFlags__);
      }
      BVar1 = BUP_SUCCESS;
    }
  }
  return BVar1;
}


void BUP_GetDate(int minutes_since_1980,backup_date *date)

{
  undefined *days_since_1980;
  byte bVar1;
  uint days;
  char cVar2;
  undefined4 days_00;
  char cVar3;
  
                    /* Divide by 1440 (number of minutes in a day) */
  days_since_1980 =
       (undefined *)
       (*(code *)(PTR_LAB_060282e0 + 0x60282a4))(minutes_since_1980,date,(int)(short)MINS_IN_DAY);
                    /* Calculate remainder as well */
  (*(code *)(PTR_LAB_060282e4 + 0x60282b0))();
                    /* divide remainder (minutes in a the partial day) by 60 to get hours */
  bVar1 = (*(code *)(PTR_LAB_060282e8 + 0x60282b8))();
  date->time = bVar1;
                    /* Get remainder % 60 to calculate mins */
  bVar1 = (*(code *)(PTR_LAB_060282ec + 0x60282c2))();
  date->min = bVar1;
                    /* Get the day of the week by modulo */
                    /* Check if for year 2100 */
  if (year_2100_in_days_since_1980 < days_since_1980) {
    bVar1 = (*(code *)(PTR_LAB_060282f4 + 0x60282d8))();
  }
  else {
    bVar1 = (*(code *)(PTR_LAB_06028370 + 0x6028302))(7);
  }
  date->week = bVar1;
  days = (*(code *)(PTR_LAB_06028374 + 0x602830e))();
                    /* Leap year calculation.  */
  if ((uint)(int)DAYS_366 < days) {
    cVar2 = (*(code *)(PTR_DAT_06028378 + 0x6028324))(days,(int)PTR_DAT_0602836c._0_2_,days - 1);
    days_00 = (*(code *)(PTR_LAB_0602837c + 0x602832e))();
    convert_days_to_month_date(days_00,&date->month,&date->day,0);
  }
  else {
    cVar2 = '\0';
    convert_days_to_month_date(days,&date->month,&date->day,0x1);
  }
  cVar3 = (*(code *)(PTR_DAT_06028380 + 0x6028356))();
  date->year = cVar3 * 0x4 + cVar2;
  return;
}


BUP_ERROR BUP_Read(BACKUP_DEVICE device,uchar *filename,uchar *output_data)

{
  int iVar1;
  BUP_ERROR BVar2;
  word block_index;
  backup_stat bStack_1c;
  
  if (device != DEVICE_SERIAL) {
    BVar2 = BUP_Stat(device,0,&bStack_1c);
    if (BVar2 != BUP_SUCCESS) {
      return BVar2;
    }
    block_index = SearchForSaveBlock((char *)filename,DEFAULT);
    if (block_index != 0) {
      BVar2 = ReadByBlockId(block_index,output_data);
      return BVar2;
    }
    return BUP_NOT_FOUND;
  }
  if ((*PTR_INTERNAL_METADATA_060277b4)->serial_connected == 0) {
    return BUP_NOT_CONNECTED;
  }
  iVar1 = (*(code *)(PTR_PTR_060277b8 + 0x60277a8))(filename,output_data,0);
  if (iVar1 == 0) {
    return BUP_SUCCESS;
  }
  if (iVar1 == 0x21) {
    return BUP_NOT_CONNECTED;
  }
  if (iVar1 == 0x23) {
    return BUP_WRITE_PROTECTED;
  }
  if (iVar1 == 0x24) {
    return BUP_NOT_FORMATTED;
  }
  if (iVar1 != 0x30) {
    if ((iVar1 != DAT_06027846) && (iVar1 != DAT_06027848)) {
      return ~BUP_SUCCESS;
    }
    return BUP_NOT_CONNECTED;
  }
  return BUP_NOT_FOUND;
}


BUP_ERROR BUP_SelPart(BACKUP_DEVICE device,ushort partition_number)

{
  int result;
  SERIAL_STRUCT auStack_1c;
  INTERNAL_METADATA **ppIVar1;
  
  ppIVar1 = PTR_INTERNAL_METADATA_06026738;
  if (device == DEVICE_SERIAL) {
    if ((*PTR_INTERNAL_METADATA_06026738)->serial_connected == 0) {
      return BUP_NOT_CONNECTED;
    }
    (*PTR_INTERNAL_METADATA_06026738)->serial_partition_number = (byte)partition_number;
                    /* serial_change_partition() */
    result = (*(code *)(PTR_LAB_0602673c + 0x602671a))
                       (&auStack_1c,(int)(char)(*ppIVar1)->serial_partition_number);
    if (result != 0) {
      if ((result != (short)SERIAL_ERROR_0x101) && (result != (short)SERIAL_ERROR_0x106)) {
        return ~BUP_SUCCESS;
      }
      return BUP_NOT_CONNECTED;
    }
  }
  return BUP_SUCCESS;
}


/* Convert jo_backup_date to minutes_since_1980 */

uint BUP_SetDate(backup_date *date)

{
  int years;
  int days;
  uint month;
  dword month_days [13];
  
  setup_days_by_month(month_days);
                    /* Divide year by 4? */
  days = (*(code *)(PTR_LAB_06028428 + 0x60283a0))();
  days = days * (short)DAYS_IN_4_YEARS;
  years = (*(code *)(PTR_DAT_0602842c + 0x60283ae))();
  if (years != 0) {
    days = days + years * (short)DAYS_IN_YEAR + 1;
  }
  if ((((date->month != 1) && (date->month < 0xd)) &&
      (month = (int)(char)date->month & 0xff, days = days + month_days[month - 2], 2 < month)) &&
     (years == 0)) {
    days = days + 1;
  }
  return (days + (((int)(char)date->day & 0xffU) - 1)) * (int)(short)MINUTES_IN_DAY +
         ((int)(char)date->time & 0xffU) * 0x3c + ((int)(char)date->min & 0xffU);
}


/* WARNING: Could not reconcile some variable overlaps */

BUP_ERROR BUP_Stat(BACKUP_DEVICE device,uint datasize,backup_stat *output_stat)

{
  int result;
  dword totalBlocks;
  byte *psat_blocks;
  uint used_block;
  uint j;
  INTERNAL_METADATA *im2;
  uint i;
  undefined2 cur_sat_block;
  undefined2 *puStack_64;
  word puStack_64_00;
  byte *cur_block_address;
  byte *sat_block_high;
  int number_of_sat_blocks_in_sat_list;
  uint datanum;
  int number_of_sat_blocks;
  uint uStack_4c;
  int reserved_blocks;
  int cart_remaining_blocks;
  byte powers_of_two [8];
  undefined auStack_38 [4];
  dword dStack_34;
  dword dStack_30;
  short sStack_2c;
  dword sat_block_low;
  INTERNAL_METADATA **im;
  INTERNAL_METADATA **pIVar1;
  bool end_sat_blocks;
  
  im = PTR_INTERNAL_METADATA_06026b14;
  puStack_64 = (undefined2 *)(uint)device;
  uStack_4c = datasize;
  if (puStack_64 != (undefined2 *)DEVICE_SERIAL) {
    setupPowersOf2Struct(powers_of_two);
    if (puStack_64 == (undefined2 *)DEVICE_INTERNAL) {
      if ((*im)->internal_connected == 0) {
        return BUP_NOT_CONNECTED;
      }
      output_stat->totalsize = g_TotalSize;
      totalBlocks = (dword)(short)g_TotalBlocks;
      output_stat->totalblock = totalBlocks;
      output_stat->blocksize = 0x40;
      (*im)->totalBlocks = totalBlocks;
      (*im)->blockSize = 0x40;
      (*im)->blockSize_in_bytes = (int)blocksize_in_bytes;
      cart_remaining_blocks = (int)usuable_blocks__;
      (*im)->backup_ram_start = backup_ram_start_;
      (*im)->offset_of_filedata_in_blocks = 2;
      (*im)->cart_format_flag_ = 0;
      (*im)->backup_ram_bad_blocks_bitmap = (dword)backup_ram_start_plus_80;
      result = checkFormatted();
      if (result != 0) {
        return BUP_NOT_FORMATTED;
      }
    }
    else {
      if (puStack_64 != (undefined2 *)DEVICE_CARTRIDGE) {
        return BUP_NOT_CONNECTED;
      }
      if ((*im)->cartridge_connected == 0) {
        return BUP_NOT_CONNECTED;
      }
      (*im)->totalBlocks = (*im)->totalBlocks_cart;
      (*im)->blockSize = (*im)->blockSize_cart;
      (*im)->offset_of_filedata_in_blocks = (*im)->cartridge_offset_to_data_in_blocks;
      (*im)->cart_format_flag_ = (*im)->cartridge_flag_2;
      (*im)->backup_ram_start = BACKUP_CART_START;
      (*im)->blockSize_in_bytes = (*im)->blockSize << 1;
      im2 = *im;
      cart_remaining_blocks = im2->totalBlocks - im2->offset_of_filedata_in_blocks;
      im2->backup_ram_bad_blocks_bitmap = (dword)(im2->backup_ram_start + im2->blockSize_in_bytes);
      output_stat->totalsize = (*im)->totalBlocks * (*im)->blockSize;
      output_stat->totalblock = (*im)->totalBlocks;
      output_stat->blocksize = (*im)->blockSize;
      result = checkFormatted();
      if (result != 0) {
        return BUP_NOT_FORMATTED;
      }
    }
    reserved_blocks = (*(code *)(PTR_DAT_06026c20 + 0x6026bda))();
    cur_block_address = (*im)->backup_ram_start + (*im)->blockSize_in_bytes * 2;
    sat_block_high = (byte *)((int)&cur_sat_block + 1);
    used_block = 0;
    puStack_64 = &cur_sat_block;
    for (i = (*im)->offset_of_filedata_in_blocks; i < (*im)->totalBlocks; i = i + 1) {
                    /* Check if block is busy (tag is negative e.g. <= 0x80 00 00 00) and not on the
                       bad block bitmap */
      if (((char)cur_block_address[1] < 0) &&
         ((*(byte *)((i >> 3) * 2 + (*PTR_INTERNAL_METADATA_06026d04)->backup_ram_bad_blocks_bitmap
                    + 1) & powers_of_two[i & 7]) == 0)) {
        used_block = used_block + 1;
        j = 0x22;
        end_sat_blocks = true;
        number_of_sat_blocks_in_sat_list = 0;
        number_of_sat_blocks = 0;
        psat_blocks = cur_block_address;
        while (end_sat_blocks) {
          while (j < (*im)->blockSize) {
            totalBlocks = j + 1;
            *(byte *)puStack_64 = psat_blocks[j * 2 + 1];
            *sat_block_high = psat_blocks[totalBlocks * 2 + 1];
            if (((cur_sat_block == 0) ||
                ((*PTR_INTERNAL_METADATA_06026dd4)->totalBlocks < used_block)) ||
               ((*PTR_INTERNAL_METADATA_06026dd4)->totalBlocks < ((int)cur_sat_block & 0xffffU))) {
              end_sat_blocks = false;
              totalBlocks = (*im)->blockSize;
            }
            else {
              used_block = used_block + 1;
              im2 = *im;
              *(byte **)(im2->sat_blocks + number_of_sat_blocks_in_sat_list * 2) =
                   im2->backup_ram_start + im2->blockSize_in_bytes * ((int)cur_sat_block & 0xffffU);
              number_of_sat_blocks_in_sat_list = number_of_sat_blocks_in_sat_list + 1;
            }
            j = totalBlocks + 1;
          }
          j = 4;
          psat_blocks = *(byte **)((*im)->sat_blocks + number_of_sat_blocks * 2);
          number_of_sat_blocks = number_of_sat_blocks + 1;
        }
      }
      cur_block_address = cur_block_address + (*im)->blockSize_in_bytes;
    }
    totalBlocks = (cart_remaining_blocks - used_block) - reserved_blocks;
    output_stat->freeblock = totalBlocks;
    if (totalBlocks == 0) {
      output_stat->freesize = 0;
    }
    else {
      output_stat->freesize = output_stat->freeblock * ((*im)->blockSize - 6) - 0x1e;
    }
                    /* What are these divisions? */
    (*(code *)(PTR_LAB_06026e8c + 0x6026de8))();
    totalBlocks = (*(code *)(DWORD_06026e90 + 0x6026df0))();
    output_stat->datanum = totalBlocks;
    return BUP_SUCCESS;
  }
                    /* Serial code start */
  if ((*PTR_INTERNAL_METADATA_06026b14)->serial_connected == 0) {
    return BUP_NOT_CONNECTED;
  }
  result = (*(code *)(DAT_06026b18 + 0x6026ad8))
                     (auStack_38,
                      (int)(char)(*PTR_INTERNAL_METADATA_06026b14)->serial_partition_number);
  if (result != 0) {
    if (result == 0x23) {
      return BUP_WRITE_PROTECTED;
    }
    if (result != 0x24) {
      if ((result != DAT_06026b82) && (result != DAT_06026b84)) {
        return ~BUP_SUCCESS;
      }
      return BUP_NOT_CONNECTED;
    }
    return BUP_NOT_FORMATTED;
  }
  output_stat->totalsize = dStack_34;
  output_stat->totalblock = dStack_30;
  output_stat->blocksize = (int)sStack_2c & 0xffff;
  datanum = uStack_4c;
  result = (*(code *)(DAT_06026b1c + 0x6026b00))
                     (&output_stat->freesize,&output_stat->freeblock,&datanum);
  if (result == 0) {
    output_stat->datanum = datanum;
    return BUP_SUCCESS;
  }
  if (result == 0x21) {
    return BUP_NOT_CONNECTED;
  }
  if (result == 0x23) {
    return BUP_WRITE_PROTECTED;
  }
  if (result != 0x24) {
    return ~BUP_SUCCESS;
  }
  return BUP_NOT_FORMATTED;
}


BUP_ERROR BUP_Verify(BACKUP_DEVICE device,uchar *filename,uchar *data)

{
  int iVar1;
  BUP_ERROR BVar2;
  short block_id;
  backup_stat stat;
  
  if (device != DEVICE_SERIAL) {
                    /* jo_backup_driver_stat
                        */
    BVar2 = (*(code *)(DAT_06027fd0 + 0x6027f90))(device,0,&stat);
    if (BVar2 != BUP_SUCCESS) {
      return BVar2;
    }
    block_id = SearchForSaveBlock((char *)filename,DEFAULT);
    if (block_id != 0) {
      BVar2 = ChecksumData(block_id,data);
      return BVar2;
    }
    return BUP_NOT_FOUND;
  }
  if ((*PTR_INTERNAL_METADATA_06027f58)->serial_connected == 0) {
    return BUP_NOT_CONNECTED;
  }
  iVar1 = (*(code *)(PTR_DAT_06027f5c + 0x6027f1a))(filename,data,1);
  if (iVar1 == 0) {
    return BUP_SUCCESS;
  }
  if (iVar1 == 0x21) {
    return BUP_NOT_CONNECTED;
  }
  if (iVar1 == 0x23) {
    return BUP_WRITE_PROTECTED;
  }
  if (iVar1 == 0x24) {
    return BUP_NOT_FORMATTED;
  }
  if ((iVar1 != DAT_06027fc8) && (iVar1 != DAT_06027fca)) {
    if (iVar1 != PTR_DAT_06027fcc._0_2_) {
      return ~BUP_SUCCESS;
    }
    return BUP_NO_MATCH;
  }
  return BUP_NOT_CONNECTED;
}


/* WARNING: Could not reconcile some variable overlaps */

BUP_ERROR BUP_Write(BACKUP_DEVICE device,backup_file *file,uchar *data,
                   BACKUP_OVERWRITE_MODE overwrite_mode)

{
  BUP_ERROR BVar1;
  short sVar3;
  uint blocks_needed;
  BUP_ERROR BVar2;
  int iVar4;
  INTERNAL_METADATA *im2;
  byte *backup_ram_start;
  uint read_offset;
  uint comment_offset;
  byte *data_to_write;
  dword *pdVar5;
  short *sat_blocks;
  int block_offset;
  undefined4 block_tag;
  uint block_index;
  uint i;
  uint uStack_74;
  char first_block_flag;
  undefined4 uStack_64;
  backup_file bStack_60;
  backup_stat device_stat;
  INTERNAL_METADATA **im;
  int write_offset;
  
  im = PTR_INTERNAL_METADATA_06026f10;
  if (device == DEVICE_SERIAL) {
    if ((*PTR_INTERNAL_METADATA_06026f10)->serial_connected == 0) {
      BVar1 = BUP_NOT_CONNECTED;
    }
    else if ((overwrite_mode == OVERWRITE_OFF) ||
            (BVar1 = BUP_Dir(DEVICE_SERIAL,file->filename,1,&bStack_60), BVar1 == BUP_SUCCESS)) {
      block_offset = (*(code *)(PTR_LAB_06026f14 + 0x6026ef2))(file,data);
      if (block_offset == 0) {
        BVar1 = BUP_SUCCESS;
      }
      else if (block_offset == 0x21) {
        BVar1 = BUP_NOT_CONNECTED;
      }
      else if (block_offset == 0x23) {
        BVar1 = BUP_WRITE_PROTECTED;
      }
      else if (block_offset == 0x24) {
        BVar1 = BUP_NOT_FORMATTED;
      }
      else if (block_offset == 0x31) {
        BVar1 = BUP_NOT_ENOUGH_SPACE;
      }
      else if ((block_offset == DAT_06026f92) || (block_offset == DAT_06026f94)) {
        BVar1 = BUP_NOT_CONNECTED;
      }
      else {
        BVar1 = ~BUP_SUCCESS;
      }
    }
    else {
      BVar1 = BUP_FOUND;
    }
  }
  else {
    BVar1 = BUP_Stat(device,0,&device_stat);
    if (BVar1 == BUP_SUCCESS) {
                    /* Check if file exists */
      sVar3 = SearchForSaveBlock((char *)file,DEFAULT);
      if (sVar3 != 0) {
        if (overwrite_mode != OVERWRITE_OFF) {
          return BUP_FOUND;
        }
        DeleteFileByID();
        BVar1 = BUP_Stat(device,0,&device_stat);
        if (BVar1 != BUP_SUCCESS) {
          return BVar1;
        }
      }
                    /* software divide = (bytes + 29)/58 */
      block_offset = (*(code *)(PTR_DAT_06027020 + 0x6026fa4))();
      blocks_needed = block_offset + 1;
      if (device_stat.freeblock < blocks_needed) {
        BVar1 = BUP_NOT_ENOUGH_SPACE;
      }
      else {
        find_free_blocks__(blocks_needed);
        sVar3 = *(*im)->sat_blocks;
        if ((*im)->cart_format_flag_ == 1) {
          uStack_64 = *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_06027024;
          (**(code **)PTR_PTR_SetOnChipReg__06027028)(0xffffffff);
        }
        first_block_flag = '\0';
        block_index = 1;
        uStack_74 = 0;
        for (i = 0; i < blocks_needed; i = i + 1) {
          read_offset = 0;
          im2 = *im;
          block_offset = ((int)im2->sat_blocks[i] & 0xffffU) * im2->blockSize_in_bytes;
          backup_ram_start = im2->backup_ram_start;
          if (first_block_flag == 0) {
            first_block_flag = 1;
            block_tag = CONCAT31(CONCAT21(CONCAT11(backup_ram_start[block_offset + 1],
                                                   backup_ram_start[block_offset + 3]),
                                          backup_ram_start[block_offset + 5]),
                                 backup_ram_start[block_offset + 7]);
            if ((*im)->cart_format_flag_ != 0) {
                    /* why does the cart flag influence the block tag?? */
              block_tag = block_tag + 1;
            }
            backup_ram_start[block_offset + 1] = block_tag._0_1_ | 0x80;
            backup_ram_start[block_offset + 3] = block_tag._1_1_;
            backup_ram_start[block_offset + 5] = block_tag._2_1_;
            backup_ram_start[block_offset + 7] = (byte)block_tag;
            read_offset = 0;
            write_offset = 8;
            do {
              iVar4 = write_offset;
                    /* write the filename
                        */
              data_to_write = file->filename + read_offset;
              read_offset = read_offset + 1;
              backup_ram_start[iVar4 + 1 + block_offset] = *data_to_write;
              write_offset = iVar4 + 2;
            } while (read_offset < 0xb);
                    /* write the language byte
                        */
            read_offset = iVar4 + 4;
            backup_ram_start[iVar4 + 3 + block_offset] = file->language;
            comment_offset = 0;
            do {
                    /* write the comment */
              backup_ram_start[read_offset + 1 + block_offset] = file->comment[comment_offset];
              write_offset = comment_offset + 1;
              comment_offset = comment_offset + 2;
              backup_ram_start[read_offset + 3 + block_offset] = file->comment[write_offset];
              read_offset = read_offset + 4;
            } while (comment_offset < 10);
            pdVar5 = &file->date;
            do {
                    /* write the date */
              data_to_write = (byte *)((int)pdVar5 + 1);
              backup_ram_start[read_offset + 1 + block_offset] = *(byte *)pdVar5;
              pdVar5 = (dword *)((int)pdVar5 + 2);
              backup_ram_start[read_offset + 3 + block_offset] = *data_to_write;
              read_offset = read_offset + 4;
            } while (pdVar5 < &file->datasize);
            pdVar5 = &file->datasize;
            do {
              data_to_write = (byte *)((int)pdVar5 + 1);
              backup_ram_start[read_offset + 1 + block_offset] = *(byte *)pdVar5;
              pdVar5 = (dword *)((int)pdVar5 + 2);
              backup_ram_start[read_offset + 3 + block_offset] = *data_to_write;
              read_offset = read_offset + 4;
            } while (pdVar5 < &file->blocksize);
NEXT_DATA_BLOCK:
            if (read_offset == 0) {
                    /* if at beginning of block, add another tag */
              block_tag = CONCAT31(CONCAT21(CONCAT11(backup_ram_start[block_offset + 1],
                                                     backup_ram_start[block_offset + 3]),
                                            backup_ram_start[block_offset + 5]),
                                   backup_ram_start[block_offset + 7]);
              if ((*im)->cart_format_flag_ != 0) {
                block_tag = block_tag + 1;
              }
              backup_ram_start[block_offset + 1] = block_tag._0_1_;
              backup_ram_start[block_offset + 3] = block_tag._1_1_;
              backup_ram_start[block_offset + 5] = block_tag._2_1_;
              backup_ram_start[block_offset + 7] = (byte)block_tag;
              read_offset = 8;
            }
                    /* write the list of sat_blocks? */
            while ((read_offset < (*im)->blockSize_in_bytes && (block_index <= blocks_needed))) {
              sat_blocks = (*im)->sat_blocks;
              backup_ram_start[read_offset + 1 + block_offset] = *(byte *)(sat_blocks + block_index)
              ;
              write_offset = read_offset + 3;
              read_offset = read_offset + 4;
              backup_ram_start[write_offset + block_offset] =
                   *(byte *)((int)(sat_blocks + block_index) + 1);
              block_index = block_index + 1;
            }
            if (read_offset != (*im)->blockSize_in_bytes) {
              first_block_flag = 0x2;
LAB_060271ba:
              if (read_offset == 0) {
                block_tag = CONCAT31(CONCAT21(CONCAT11(backup_ram_start[block_offset + 1],
                                                       backup_ram_start[block_offset + 3]),
                                              backup_ram_start[block_offset + 5]),
                                     backup_ram_start[block_offset + 7]);
                if ((*im)->cart_format_flag_ != 0) {
                  block_tag = block_tag + 1;
                }
                backup_ram_start[block_offset + 1] = block_tag._0_1_;
                backup_ram_start[block_offset + 3] = block_tag._1_1_;
                backup_ram_start[block_offset + 5] = block_tag._2_1_;
                backup_ram_start[block_offset + 7] = (byte)block_tag;
                read_offset = 8;
              }
              while (read_offset < (*im)->blockSize_in_bytes) {
                write_offset = read_offset + 1;
                if (uStack_74 < file->datasize) {
                  backup_ram_start[write_offset + block_offset] = data[uStack_74];
                  read_offset = read_offset + 2;
                  uStack_74 = uStack_74 + 1;
                }
                else {
                  read_offset = read_offset + 2;
                  backup_ram_start[write_offset + block_offset] = 0;
                }
              }
            }
          }
          else {
            if (first_block_flag == 0x1) goto NEXT_DATA_BLOCK;
            if (first_block_flag == 0x2) goto LAB_060271ba;
          }
          if ((*im)->cart_format_flag_ == 1) {
            (*(code *)(PTR_LAB_060272d4 + 0x6027262))();
          }
        }
        if ((*im)->cart_format_flag_ == 1) {
          (**(code **)PTR_PTR_SetOnChipReg__060272d8)(uStack_64);
        }
        BVar1 = ChecksumData(sVar3,data);
        if (*(int *)&(*im)->bad_block != 0) {
          BVar2 = mark_bad_blocks___(*(uint *)&(*im)->bad_block & 0xffff);
          if (BVar2 != BUP_SUCCESS) {
            BVar1 = BVar2;
          }
          if (sVar3 != 0) {
            DeleteFileByID((int)sVar3);
          }
        }
      }
    }
  }
                    /* File exists and we did not specify overwrite mode */
  return BVar1;
}


BUP_ERROR ChecksumData(short block_id,byte *input_data)

{
  byte *backup_ram_start;
  uint j;
  int iVar1;
  INTERNAL_METADATA *im2;
  undefined4 *save_size_ptr;
  short *saved_sat_blocks;
  int block_type_flag;
  uint bytes_read;
  int curBlock;
  int i;
  int block_offset;
  undefined4 save_size;
  byte abStack_24 [4];
  byte *pbStack_20;
  INTERNAL_METADATA **im;
  byte *input_data_curr;
  
  im = PTR_INTERNAL_METADATA_060280c8;
  block_type_flag = 0;
  curBlock = 1;
  bytes_read = 0;
  *(undefined4 *)&(*PTR_INTERNAL_METADATA_060280c8)->bad_block = 0;
  *(*im)->sat_blocks = block_id;
  i = 0;
  do {
    if ((*im)->sat_blocks[i] == 0) {
      return BUP_SUCCESS;
    }
    j = 0;
    if ((*im)->totalBlocks < ((int)(*im)->sat_blocks[i] & 0xffffU)) {
      return BUP_BROKEN;
    }
    im2 = *im;
    block_offset = ((int)im2->sat_blocks[i] & 0xffffU) * im2->blockSize_in_bytes;
    backup_ram_start = im2->backup_ram_start;
    if (block_type_flag == 0) {
      block_type_flag = 1;
      j = 0x3c;
      pbStack_20 = abStack_24;
                    /* Read the save sizve from the SAT header
                        */
      save_size_ptr = &save_size;
      do {
        *(byte *)save_size_ptr = backup_ram_start[j + 1 + block_offset];
        *(byte *)((int)save_size_ptr + 1) = backup_ram_start[j + 3 + block_offset];
        save_size_ptr = (undefined4 *)((int)save_size_ptr + 2);
        j = j + 4;
      } while (save_size_ptr < pbStack_20);
SAT_CONT_BLOCK:
      if (j == 0) {
        j = 8;
      }
                    /* Parse the SAT block list */
      for (; (j < (*im)->blockSize_in_bytes && ((*im)->sat_blocks[curBlock + -1] != 0));
          curBlock = curBlock + 1) {
        saved_sat_blocks = (*im)->sat_blocks;
        *(byte *)(saved_sat_blocks + curBlock) = backup_ram_start[j + 1 + block_offset];
        iVar1 = j + 3;
        j = j + 4;
        *(byte *)((int)(saved_sat_blocks + curBlock) + 1) = backup_ram_start[iVar1 + block_offset];
      }
      if ((*im)->sat_blocks[curBlock + -1] == 0) {
        block_type_flag = 2;
SAT_END_BLOCK:
        if (j == 0) {
          j = 8;
        }
        while ((j < (*im)->blockSize_in_bytes && (bytes_read < save_size))) {
          iVar1 = j + 1;
          input_data_curr = input_data + bytes_read;
          j = j + 2;
          bytes_read = bytes_read + 1;
          if (*input_data_curr != backup_ram_start[iVar1 + block_offset]) {
                    /* found a bad block */
            *(uint *)&(*im)->bad_block = (int)(*im)->sat_blocks[i] & 0xffff;
            return BUP_NO_MATCH;
          }
        }
      }
    }
    else {
      if (block_type_flag == 1) goto SAT_CONT_BLOCK;
      if (block_type_flag == 2) goto SAT_END_BLOCK;
    }
    i = i + 1;
  } while( true );
}


int CountReservedBlocks(void)

{
  uint i;
  int reserved_blocks;
  byte powers_of_two [12];
  INTERNAL_METADATA **im;
  
  im = PTR_INTERNAL_METADATA_06028170;
  (*(code *)(DAT_06028174 + 0x6028166))(powers_of_two);
  reserved_blocks = 0;
  for (i = (*im)->offset_of_filedata_in_blocks; i < (*im)->totalBlocks; i = i + 1) {
    if ((*(byte *)((i >> 3) * 2 + (*im)->backup_ram_bad_blocks_bitmap + 1) & powers_of_two[i & 7])
        != 0) {
      reserved_blocks = reserved_blocks + 1;
    }
  }
  return reserved_blocks;
}


/* WARNING: Could not reconcile some variable overlaps */

void DeleteFileByID(uint block)

{
  byte *backup_ram_start;
  uint i;
  int block_offset;
  dword tag;
  byte *pbStack_2c;
  byte *pbStack_28;
  undefined4 uStack_24;
  byte *pbStack_20;
  INTERNAL_METADATA **im;
  
  im = PTR_INTERNAL_METADATA_06027c94;
  block_offset = (*PTR_INTERNAL_METADATA_06027c94)->blockSize_in_bytes * (block & 0xffff);
  backup_ram_start = (*PTR_INTERNAL_METADATA_06027c94)->backup_ram_start;
  pbStack_2c = (byte *)((int)&tag + 1);
  pbStack_28 = (byte *)((int)&tag + 2);
  pbStack_20 = (byte *)((int)&tag + 3);
                    /* Remove high bit from tag */
  tag = CONCAT31(CONCAT21(CONCAT11(backup_ram_start[block_offset + 1],
                                   backup_ram_start[block_offset + 3]),
                          backup_ram_start[block_offset + 5]),backup_ram_start[block_offset + 7]) &
        0x7fffffff;
  if ((*PTR_INTERNAL_METADATA_06027c94)->cart_format_flag_ != 0) {
    tag = tag + 1 & 0x7f;
  }
                    /* TODO: what happens when flag_format is 1? presumably this is a cart */
  if ((*PTR_INTERNAL_METADATA_06027c94)->cart_format_flag_ == 1) {
    uStack_24 = *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_06027c98;
    (**(code **)PTR_PTR_SetOnChipReg__06027c9c)(0xffffffff);
  }
                    /* Write new tag (with high bit off) */
  backup_ram_start[block_offset + 1] = tag._0_1_;
  backup_ram_start[block_offset + 3] = *pbStack_2c;
  backup_ram_start[block_offset + 5] = *pbStack_28;
  backup_ram_start[block_offset + 7] = *pbStack_20;
  i = 8;
  if ((*im)->cart_format_flag_ == 1) {
    for (; i < (*im)->blockSize_in_bytes; i = i + 2) {
      backup_ram_start[i + 1 + block_offset] = 0;
    }
    (*(code *)(DAT_06027d40 + 0x6027cba))();
    (**(code **)PTR_PTR_SetOnChipReg__06027d44)(uStack_24);
  }
  return;
}


void Init(INTERNAL_METADATA *im_out,backup_config *config)

{
  byte cart_type_flag;
  int iVar1;
  dword totalblocks_cart;
  dword blocksize_cart;
  undefined *CARTRIDGE_MEMORY_END_2;
  INTERNAL_METADATA **im;
  
  im = PTR_INTERNAL_METADATA_0602653c;
  *PTR_INTERNAL_METADATA_0602653c = im_out;
  im_out->function_pointers[0] = PTR_Onchip_BCR1_06026540 + 0x6026440;
  im_out->function_pointers[1] = (undefined *)(DAT_06026544 + 0x6026448);
  im_out->function_pointers[2] = (undefined *)(DAT_06026548 + 0x6026450);
  im_out->function_pointers[3] = (undefined *)(DAT_0602654c + 0x6026458);
  im_out->function_pointers[4] = (undefined *)(DAT_06026550 + 0x6026460);
  im_out->function_pointers[5] = PTR_LAB_06026554 + 0x6026468;
  im_out->function_pointers[6] = PTR_LAB_06026558 + 0x6026470;
  im_out->function_pointers[7] = PTR_PTR_0602655c + 0x6026478;
  im_out->function_pointers[8] = PTR_LAB_06026560 + 0x6026480;
  im_out->function_pointers[9] = PTR_PTR_DAT_06026564 + 0x6026488;
  im_out->function_pointers[10] = (undefined *)(DAT_06026568 + 0x6026490);
  (*im)->sat_blocks = (short *)(*im + 1);
  config->unit_id = 1;
  config->partition = 1;
  (*im)->internal_connected = 1;
  CARTRIDGE_MEMORY_END_2 = CARTRIDGE_MEMORY_END;
  totalblocks_cart = (dword)totalblocks_cart_0x400;
  blocksize_cart = (dword)blocksize_cart_0x200;
  if (((int)(char)*CARTRIDGE_MEMORY_END & 0xe0U) == 0) {
    if ((*CARTRIDGE_MEMORY_END & 0x18) == 0) {
      config[1].unit_id = 0;
      config[1].partition = 1;
      (*im)->cartridge_connected = 0;
      if ((*CARTRIDGE_MEMORY_END_2 & 7) == 1) {
        (*im)->cartridge_offset_to_data_in_blocks = 2;
        (*im)->cartridge_flag_2 = 1;
        (*(code *)(DAT_06026668 + 0x60265e4))();
        if (*PTR_DAT_0602666c == '\x1f') {
          if (((int)(char)*PTR_DAT_06026670 & 0xffU) == 0x5b) {
            config[1].unit_id = 2;
            (*im)->cartridge_connected = 1;
            (*im)->totalBlocks_cart = totalblocks_cart;
            (*im)->blockSize_cart = blocksize_cart;
          }
          else if (((int)(char)*PTR_DAT_06026670 & 0xffU) == (int)PTR_DAT_06026664._0_2_) {
            config[1].unit_id = 2;
            (*im)->cartridge_connected = 1;
            (*im)->totalBlocks_cart = (int)totalblocks_cart_0x800;
            (*im)->blockSize_cart = (int)blocksize_cart_0x100;
          }
        }
        (*(code *)(DAT_06026674 + 0x6026644))();
      }
    }
  }
  else {
                    /* Check for cartridge */
    if (((int)(char)*CARTRIDGE_MEMORY_END & 0xe0U) == 0x20) {
      config[1].unit_id = 2;
      config[1].partition = 1;
      (*im)->cartridge_connected = 1;
      (*im)->cartridge_offset_to_data_in_blocks = 2;
      (*im)->cartridge_flag_2 = 0;
      cart_type_flag = *CARTRIDGE_MEMORY_END_2 & 7;
      if (cart_type_flag == 0) {
        (*im)->totalBlocks_cart = totalblocks_cart;
        (*im)->blockSize_cart = blocksize_cart;
      }
      else if (cart_type_flag == 1) {
        (*im)->totalBlocks_cart = totalblocks_cart;
        (*im)->blockSize_cart = blocksize_cart;
      }
      else if (cart_type_flag == 2) {
        (*im)->totalBlocks_cart = (int)totalblock_cart_0x800;
        (*im)->blockSize_cart = blocksize_cart;
      }
      else if (cart_type_flag == 3) {
        (*im)->totalBlocks_cart = (int)totalblocks_cart_0x1000;
        (*im)->blockSize_cart = blocksize_cart;
      }
      else if (cart_type_flag == 4) {
        (*im)->totalBlocks_cart = (int)totalblocks_cart_0x1000;
        (*im)->blockSize_cart = totalblocks_cart;
      }
      else {
        config[1].unit_id = 0;
        config[1].partition = 0;
        (*im)->cartridge_connected = 0;
      }
    }
    else {
      config[1].unit_id = 0;
      config[1].partition = 0;
      (*im)->cartridge_connected = 0;
    }
  }
                    /* Check for serial connection */
  iVar1 = (*(code *)(DAT_06026734 + 0x6026690))(config + 2);
  if (iVar1 == 0) {
    if (config[2].unit_id < 0x10) {
      (*im)->serial_connected = 1;
    }
    else {
      config[2].unit_id = 0;
      config[2].partition = 0;
    }
  }
  else {
    (*im)->serial_connected = 0;
    config[2].unit_id = 0;
    config[2].partition = 0;
  }
  return;
}


void InitBackupRamFormatString(char *backupFormatStr)

{
  *backupFormatStr = 'B';
  backupFormatStr[1] = 'a';
  backupFormatStr[2] = 'c';
  backupFormatStr[3] = 'k';
  backupFormatStr[4] = 'U';
  backupFormatStr[5] = 'p';
  backupFormatStr[6] = 'R';
  backupFormatStr[7] = 'a';
  backupFormatStr[8] = 'm';
  backupFormatStr[9] = ' ';
  backupFormatStr[10] = 'F';
  backupFormatStr[0xb] = 'o';
  backupFormatStr[0xc] = 'r';
  backupFormatStr[0xd] = 'm';
  backupFormatStr[0xe] = 'a';
  backupFormatStr[0xf] = 't';
  return;
}


/* WARNING: Globals starting with '_' overlap smaller symbols at the same address */

undefined4 MaskInterrupts_ABus2_(void)

{
  undefined4 uVar1;
  
  uVar1 = *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_060284cc;
  (**(code **)PTR_PTR_SetOnChipReg__060284d0)(0xffffffff);
  *PTR_0x2400aaab = (char)DATA_0xAA;
  *PTR_0x24005555 = 0x55;
  *PTR_0x2400aaab = (char)_DATA_0x00;
  (**(code **)PTR_PTR_SetOnChipReg__060284d0)(uVar1);
  uVar1 = (*(code *)(PTR_DAT_060284e0 + 0x60284bc))();
  return uVar1;
}


undefined4 MaskInterrupts_ABus_(void)

{
  undefined4 value_0xfffff17c;
  
  value_0xfffff17c = *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_060284cc;
  (**(code **)PTR_PTR_SetOnChipReg__060284d0)(0xffffffff);
  *PTR_0x2400aaab = (char)DATA_0xAA;
  *PTR_0x24005555 = 0x55;
  *PTR_0x2400aaab = (char)0x90;
  (**(code **)PTR_PTR_SetOnChipReg__060284d0)(value_0xfffff17c);
  value_0xfffff17c = (*(code *)(PTR_Onchip_DMA0R_2_060284dc + 0x602847e))();
  return value_0xfffff17c;
}


BUP_ERROR ReadByBlockId(word fileID,byte *outBuf)

{
  byte *backup_ram_start;
  uint j;
  int data_index;
  INTERNAL_METADATA *im2;
  ushort *next_block_id;
  short *saved_sat_blocks;
  int block_type_flag;
  uint bytes_read;
  int i;
  uint curBlock;
  int block_offset;
  dword save_size;
  ushort auStack_24 [2];
  ushort *puStack_20;
  INTERNAL_METADATA **im;
  
  im = PTR_INTERNAL_METADATA_06027a90;
  block_type_flag = 0;
  curBlock = 1;
  bytes_read = 0;
  i = 0;
  *(*PTR_INTERNAL_METADATA_06027a90)->sat_blocks = fileID;
  do {
    if ((*im)->sat_blocks[i] == 0) {
      return BUP_SUCCESS;
    }
    j = 0;
    if ((*im)->totalBlocks < ((int)(*im)->sat_blocks[i] & 0xffffU)) {
      return BUP_BROKEN;
    }
    im2 = *im;
    block_offset = ((int)im2->sat_blocks[i] & 0xffffU) * im2->blockSize_in_bytes;
    backup_ram_start = im2->backup_ram_start;
    if (block_type_flag == 0) {
      block_type_flag = 1;
                    /* Read the save size from the SAT Header
                        */
      j = 0x3c;
      puStack_20 = auStack_24;
      next_block_id = (ushort *)&save_size;
      do {
        *(byte *)next_block_id = backup_ram_start[j + 1 + block_offset];
        *(byte *)((int)next_block_id + 1) = backup_ram_start[j + 3 + block_offset];
        next_block_id = next_block_id + 1;
        j = j + 4;
      } while (next_block_id < puStack_20);
SAT_CONT_BLOCK:
      if (j == 0) {
        j = 8;
      }
                    /* Parse the sat block lists */
      for (; (j < (*im)->blockSize_in_bytes && ((*im)->sat_blocks[curBlock - 1] != 0));
          curBlock = curBlock + 1) {
        saved_sat_blocks = (*im)->sat_blocks;
        *(byte *)(saved_sat_blocks + curBlock) = backup_ram_start[j + 1 + block_offset];
        data_index = j + 3;
        j = j + 4;
        *(byte *)((int)(saved_sat_blocks + curBlock) + 1) =
             backup_ram_start[data_index + block_offset];
      }
      if ((*im)->sat_blocks[curBlock - 1] == 0) {
        block_type_flag = 2;
SAT_END_BLOCK:
        if (j == 0) {
          j = 8;
        }
                    /* Copy save data
                        */
        for (; (j < (*im)->blockSize_in_bytes && (bytes_read < save_size));
            bytes_read = bytes_read + 1) {
          data_index = j + 1;
          j = j + 2;
          outBuf[bytes_read] = backup_ram_start[data_index + block_offset];
        }
      }
    }
    else {
      if (block_type_flag == 1) goto SAT_CONT_BLOCK;
      if (block_type_flag == 2) goto SAT_END_BLOCK;
    }
    i = i + 1;
    if ((*im)->totalBlocks < curBlock) {
      return BUP_BROKEN;
    }
  } while( true );
}


/* Find filename in the backup memory. Returns the block index on success or 0 on failure. Search
   mode is None, Save, and Resume.  */

uint SearchForSaveBlock(char *filename,SEARCH_MODE search_mode)

{
  INTERNAL_METADATA *im;
  uint j;
  uint currBlockIndex;
  byte *backup_ram;
  byte powers_of_two [16];
  INTERNAL_METADATA **pim;
  
  pim = PTR_INTERNAL_METADATA_060278c8;
  (*(code *)(DAT_060278cc + 0x6027876))(powers_of_two);
  if (search_mode == RESUME_SEARCH) {
    (*pim)->last_found_block_search = (*pim)->last_found_block_search + 1;
  }
  else {
    (*pim)->last_found_block_search = (*pim)->offset_of_filedata_in_blocks;
  }
  im = *pim;
  currBlockIndex = im->last_found_block_search;
                    /* Loop through all blocks */
  backup_ram = im->backup_ram_start + im->last_found_block_search * im->blockSize_in_bytes;
  do {
    if ((*pim)->totalBlocks <= currBlockIndex) {
      return 0;
    }
                    /* Look at all SAT_START_BLOCKs. These start with 0x80000000 and contain the
                       SAT_START_BLOCK_HEADER structure. This structure contains the filename. We
                       need to read every other byte because only every other byte is mapped in.  */
    if (((char)backup_ram[1] < 0) &&
       ((*(byte *)((currBlockIndex >> 3) * 2 +
                   (*PTR_INTERNAL_METADATA_06027998)->backup_ram_bad_blocks_bitmap + 1) &
        powers_of_two[currBlockIndex & 7]) == 0)) {
      j = 0;
      do {
        if (backup_ram[j * 2 + 9] == filename[j]) {
          if ((j == 0xb) || (filename[j] == '\0')) {
            (*pim)->last_found_block_search = currBlockIndex;
            return currBlockIndex & 0xffff;
          }
        }
        else {
          if ((filename[j] == '\0') && (search_mode != DEFAULT)) {
            (*pim)->last_found_block_search = currBlockIndex;
            return currBlockIndex & 0xffff;
          }
          if (j == 0xb) {
            (*pim)->last_found_block_search = currBlockIndex;
            return currBlockIndex & 0xffff;
          }
          j = 0xc;
        }
        j = j + 1;
      } while (j < 0xc);
    }
    backup_ram = backup_ram + (*pim)->blockSize_in_bytes;
    currBlockIndex = currBlockIndex + 1;
  } while( true );
}


void SetOnChipReg_(undefined4 param_1)

{
  undefined *puVar1;
  
  puVar1 = PTR_SCU_IMS_060007e8;
  *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_060007ec = param_1;
  *(undefined4 *)puVar1 = param_1;
  *(int *)(puVar1 + 4) = (int)(short)param_1;
  if (-1 < (short)param_1) {
    *(undefined4 *)(puVar1 + 8) = 1;
  }
  return;
}


undefined4 WaitLoop__(void)

{
  dword counter;
  
  counter = 47000_iterations;
  do {
    counter = counter - 1_DEC;
  } while (counter != 0);
  return 0;
}


/* WARNING: Unknown calling convention -- yet parameter storage is locked */

int checkFormatted(void)

{
  uint j;
  uint i;
  byte *backup_ram;
  byte backupFormatStr [24];
  INTERNAL_METADATA **puVar1;
  
  puVar1 = PTR_INTERNAL_METADATA_06026e94;
  InitBackupRamFormatString((char *)backupFormatStr);
  backup_ram = (*puVar1)->backup_ram_start;
  i = 0;
  do {
    if ((*puVar1)->blockSize - 0xf <= i) {
      return 1;
    }
    if (backup_ram[i * 2 + 1] == backupFormatStr[0]) {
      j = 0;
      do {
        if (backup_ram[(i + j) * 2 + 1] == backupFormatStr[j]) {
          if (j == 0xf) {
            return 0;
          }
        }
        else {
          j = 0x10;
        }
        j = j + 1;
      } while (j < 0x10);
    }
    i = i + 1;
  } while( true );
}


void convert_days_to_month_date(uint days,uchar *month,uchar *day,uchar leap_year)

{
  uint i;
  uint months [12];
  char days2;
  
  setup_days_by_month(months);
  i = 1;
  days2 = (char)days;
  if (days < months[0]) {
    *month = 1;
    *day = days2 + 1;
  }
  else if (leap_year == 0) {
    for (; (months[i] <= days && (i < 0xb)); i = i + 1) {
    }
    *month = (char)i + 1;
    *day = (days2 - (char)months[i - 1]) + 1;
  }
  else {
    for (; (months[i] < days && (i < 0xb)); i = i + 1) {
    }
    *month = (char)i + 1;
    *day = days2 - (char)months[i - 1];
    if (*month == 2) {
      *day = *day + 1;
    }
  }
  return;
}


int crazyDiv2(int divisor,int dividend)

{
  bool bVar1;
  bool bVar2;
  uint uVar3;
  char cVar4;
  bool bVar5;
  bool bVar6;
  uint uVar7;
  uint uVar8;
  uint uVar9;
  uint uVar11;
  uint uVar12;
  uint uVar14;
  uint uVar15;
  uint uVar16;
  uint uVar17;
  uint uVar18;
  uint uVar19;
  uint uVar20;
  uint uVar21;
  uint uVar22;
  uint uVar23;
  uint uVar24;
  uint uVar25;
  uint uVar26;
  uint uVar27;
  uint uVar28;
  uint uVar29;
  uint uVar30;
  uint uVar31;
  uint uVar32;
  uint uVar33;
  uint uVar34;
  uint uVar35;
  uint uVar36;
  uint uVar37;
  uint uVar38;
  uint uVar39;
  uint uVar40;
  uint uVar41;
  uint uVar42;
  uint uVar10;
  uint uVar13;
  
  if (divisor != 0) {
    uVar8 = (uint)((dividend & 0x80000000U) != 0);
    uVar13 = -uVar8;
    uVar7 = dividend - (uint)(uVar13 != 0);
    bVar1 = (uVar13 & 0x80000000) != 0;
    bVar2 = (divisor & 0x80000000U) != 0;
    uVar3 = (uint)bVar2 << 9;
    uVar12 = uVar7 * 2;
    uVar8 = uVar8 * -2 | (uint)((uVar7 & 0x80000000) != 0);
    bVar5 = bVar1 == bVar2;
    bVar6 = bVar2 == ((uVar13 & 0x80000000) != 0);
    uVar7 = (uint)bVar5 * (uVar8 - divisor) + (uint)!bVar5 * (uVar8 + divisor);
    cVar4 = bVar5 * (uVar8 < uVar7) + !bVar5 * (uVar7 < uVar8);
    uVar8 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar13 = uVar3 | uVar8;
    uVar9 = uVar7 * 2 | (uint)((uVar12 & 0x80000000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar7 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar9 - divisor) + (uint)!bVar5 * (uVar9 + divisor);
    cVar4 = bVar5 * (uVar9 < uVar10) + !bVar5 * (uVar10 < uVar9);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar14 = uVar3 | uVar8 & 0xfffffeff | uVar13;
    uVar9 = uVar3 | uVar8 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x40000000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar15 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x20000000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar16 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x10000000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar17 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x8000000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar18 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x4000000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar19 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x2000000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar20 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x1000000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar21 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x800000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar22 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x400000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar23 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x200000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar24 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x100000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar25 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x80000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar26 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x40000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar27 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x20000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar28 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x10000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar29 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x8000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar30 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x4000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar31 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x2000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar32 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x1000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar33 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x800) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar34 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x400) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar35 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x200) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar36 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x100) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar37 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x80) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar38 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x40) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar39 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x20) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar40 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x10) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar41 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 8) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar42 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 4) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar11 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar12 = uVar10 * 2 | (uint)((uVar12 & 2) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar13 = (uint)bVar5 * (uVar12 - divisor) + (uint)!bVar5 * (uVar12 + divisor);
    cVar4 = bVar5 * (uVar12 < uVar13) + !bVar5 * (uVar13 < uVar12);
    uVar13 = uVar9 | uVar7 & 0xfffffeff |
             (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    return ((((((((((((((((((((((((((((((((uint)(((byte)((uVar3 | uVar8) >> 8) & 1) ==
                                                ((byte)((uVar3 | uVar8) >> 9) & 1)) << 1 |
                                         (uint)(((byte)(uVar14 >> 8) & 1) ==
                                               ((byte)(uVar14 >> 9) & 1))) << 1 |
                                        (uint)(((byte)(uVar15 >> 8) & 1) ==
                                              ((byte)(uVar15 >> 9) & 1))) << 1 |
                                       (uint)(((byte)(uVar16 >> 8) & 1) == ((byte)(uVar16 >> 9) & 1)
                                             )) << 1 |
                                      (uint)(((byte)(uVar17 >> 8) & 1) == ((byte)(uVar17 >> 9) & 1))
                                      ) << 1 | (uint)(((byte)(uVar18 >> 8) & 1) ==
                                                     ((byte)(uVar18 >> 9) & 1))) << 1 |
                                    (uint)(((byte)(uVar19 >> 8) & 1) == ((byte)(uVar19 >> 9) & 1)))
                                    << 1 | (uint)(((byte)(uVar20 >> 8) & 1) ==
                                                 ((byte)(uVar20 >> 9) & 1))) << 1 |
                                  (uint)(((byte)(uVar21 >> 8) & 1) == ((byte)(uVar21 >> 9) & 1))) <<
                                  1 | (uint)(((byte)(uVar22 >> 8) & 1) == ((byte)(uVar22 >> 9) & 1))
                                 ) << 1 | (uint)(((byte)(uVar23 >> 8) & 1) ==
                                                ((byte)(uVar23 >> 9) & 1))) << 1 |
                               (uint)(((byte)(uVar24 >> 8) & 1) == ((byte)(uVar24 >> 9) & 1))) << 1
                              | (uint)(((byte)(uVar25 >> 8) & 1) == ((byte)(uVar25 >> 9) & 1))) << 1
                             | (uint)(((byte)(uVar26 >> 8) & 1) == ((byte)(uVar26 >> 9) & 1))) << 1
                            | (uint)(((byte)(uVar27 >> 8) & 1) == ((byte)(uVar27 >> 9) & 1))) << 1 |
                           (uint)(((byte)(uVar28 >> 8) & 1) == ((byte)(uVar28 >> 9) & 1))) << 1 |
                          (uint)(((byte)(uVar29 >> 8) & 1) == ((byte)(uVar29 >> 9) & 1))) << 1 |
                         (uint)(((byte)(uVar30 >> 8) & 1) == ((byte)(uVar30 >> 9) & 1))) << 1 |
                        (uint)(((byte)(uVar31 >> 8) & 1) == ((byte)(uVar31 >> 9) & 1))) << 1 |
                       (uint)(((byte)(uVar32 >> 8) & 1) == ((byte)(uVar32 >> 9) & 1))) << 1 |
                      (uint)(((byte)(uVar33 >> 8) & 1) == ((byte)(uVar33 >> 9) & 1))) << 1 |
                     (uint)(((byte)(uVar34 >> 8) & 1) == ((byte)(uVar34 >> 9) & 1))) << 1 |
                    (uint)(((byte)(uVar35 >> 8) & 1) == ((byte)(uVar35 >> 9) & 1))) << 1 |
                   (uint)(((byte)(uVar36 >> 8) & 1) == ((byte)(uVar36 >> 9) & 1))) << 1 |
                  (uint)(((byte)(uVar37 >> 8) & 1) == ((byte)(uVar37 >> 9) & 1))) << 1 |
                 (uint)(((byte)(uVar38 >> 8) & 1) == ((byte)(uVar38 >> 9) & 1))) << 1 |
                (uint)(((byte)(uVar39 >> 8) & 1) == ((byte)(uVar39 >> 9) & 1))) << 1 |
               (uint)(((byte)(uVar40 >> 8) & 1) == ((byte)(uVar40 >> 9) & 1))) << 1 |
              (uint)(((byte)(uVar41 >> 8) & 1) == ((byte)(uVar41 >> 9) & 1))) << 1 |
             (uint)(((byte)(uVar42 >> 8) & 1) == ((byte)(uVar42 >> 9) & 1))) << 1 |
            (uint)(((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1))) << 1 |
           (uint)(((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1))) + (uint)(bVar2 != bVar1);
  }
  *(undefined4 *)PTR_DAT_06029a28 = DAT_06029a2c;
  return 0;
}


undefined4 find_free_blocks__(uint blocks_needed_)

{
  ushort uVar1;
  uint read_offset2;
  int power_of_two_index;
  short *sat_blocks;
  byte *backup_ram_save_area_start2;
  byte *extraout_r3;
  INTERNAL_METADATA *im3;
  dword read_offset2_high;
  uint j;
  ushort *puVar2;
  byte *tag_ptr;
  ushort *puVar3;
  uint total_blocks_divided_8;
  int offset;
  undefined2 block_index;
  uint block_index2;
  byte *backup_ram_save_area_start;
  undefined2 *block_index_low;
  uint tag;
  byte *block_index_high;
  int found_busy_blocks_index;
  int current_block_index;
  byte powers_of_two [8];
  INTERNAL_METADATA **im2;
  uint k;
  char read_offset;
  bool some_flag;
  
  im2 = PTR_INTERNAL_METADATA_060274a0;
  block_index_low = &block_index;
  setupPowersOf2Struct(powers_of_two);
  for (k = 0; k < (*im2)->totalBlocks >> 3; k = k + 1) {
    *(undefined *)((int)(*im2)->sat_blocks + k) =
         *(undefined *)(k * 2 + (*im2)->backup_ram_bad_blocks_bitmap + 1);
  }
  im3 = *im2;
  backup_ram_save_area_start = im3->backup_ram_start + im3->blockSize_in_bytes * 2;
  total_blocks_divided_8 = im3->totalBlocks >> 3;
  sat_blocks = im3->sat_blocks;
  tag_ptr = (byte *)&tag;
  block_index_high = (byte *)((int)&block_index + 1);
                    /* Walk all of the blocks after the header. Find blocks that are busy (0x800000)
                       tag and not on the bad block bitmap. */
  for (k = (*im2)->offset_of_filedata_in_blocks; k < (*im2)->totalBlocks; k = k + 1) {
    if (((char)backup_ram_save_area_start[1] < 0) &&
       ((*(byte *)((k >> 3) * 2 + (*PTR_INTERNAL_METADATA_06027540)->backup_ram_bad_blocks_bitmap +
                  1) & powers_of_two[k & 7]) == 0)) {
      backup_ram_save_area_start2 = (byte *)((k >> 3) + (int)(*im2)->sat_blocks);
      *backup_ram_save_area_start2 = *backup_ram_save_area_start2 | powers_of_two[k & 7];
      read_offset = 34;
      some_flag = true;
      found_busy_blocks_index = 0;
      current_block_index = 0;
      backup_ram_save_area_start2 = backup_ram_save_area_start;
                    /* Walk the sat block list of this busy save */
      while (some_flag) {
        read_offset2 = (uint)read_offset;
        while (read_offset2 < (*im2)->blockSize) {
          read_offset2_high = read_offset2 + 1;
          *(byte *)block_index_low = backup_ram_save_area_start2[read_offset2 * 2 + 1];
          *block_index_high = backup_ram_save_area_start2[read_offset2_high * 2 + 1];
          if (block_index == 0) {
                    /* found 0x0000 terminator block index */
            some_flag = false;
            read_offset2_high = (*im2)->blockSize;
          }
          else if (((int)block_index & 0xffffU) < (*im2)->totalBlocks) {
                    /* Unclear?? save block index to sat_blocks? */
            block_index2 = (int)block_index & 0xffff;
            power_of_two_index = (*(code *)(PTR_LAB_060275f8 + 0x602756c))();
            *extraout_r3 = *extraout_r3 | powers_of_two[power_of_two_index];
            *(byte **)((int)sat_blocks + found_busy_blocks_index * 4 + total_blocks_divided_8) =
                 (*im2)->backup_ram_start +
                 (*im2)->blockSize_in_bytes * ((int)block_index & 0xffffU);
            found_busy_blocks_index = found_busy_blocks_index + 1;
          }
          read_offset2 = read_offset2_high + 1;
        }
        read_offset = 4;
        backup_ram_save_area_start2 =
             *(byte **)((int)sat_blocks + current_block_index * 4 + total_blocks_divided_8);
        current_block_index = current_block_index + 1;
      }
    }
    backup_ram_save_area_start = backup_ram_save_area_start + (*im2)->blockSize_in_bytes;
  }
  k = 0;
  while (k < blocks_needed_) {
    read_offset2 = 0xffffffff;
    for (j = (*im2)->offset_of_filedata_in_blocks; j < (*im2)->totalBlocks; j = j + 1) {
      if ((*(byte *)((j >> 3) + (int)(*im2)->sat_blocks) & powers_of_two[j & 7]) == 0) {
        backup_ram_save_area_start2 = (*im2)->backup_ram_start;
        offset = (*im2)->blockSize_in_bytes * j;
                    /* read the first 4 bytes of the tag? */
        *tag_ptr = backup_ram_save_area_start2[offset + 1];
        *(byte *)((int)tag_ptr + 1) = backup_ram_save_area_start2[offset + 3];
        *(byte *)((int)tag_ptr + 2) = backup_ram_save_area_start2[offset + 5];
        *(byte *)((int)tag_ptr + 3) = backup_ram_save_area_start2[offset + 7];
        if (tag < read_offset2) {
          read_offset2 = tag;
        }
      }
    }
    for (read_offset2_high = (*im2)->offset_of_filedata_in_blocks;
        read_offset2_high < (*im2)->totalBlocks; read_offset2_high = read_offset2_high + 1) {
      j = k;
      if ((*(byte *)((read_offset2_high >> 3) + (int)(*im2)->sat_blocks) &
          powers_of_two[read_offset2_high & 7]) == 0) {
        backup_ram_save_area_start2 = (*im2)->backup_ram_start;
        power_of_two_index = (*im2)->blockSize_in_bytes * read_offset2_high;
        *tag_ptr = backup_ram_save_area_start2[power_of_two_index + 1];
        *(byte *)((int)tag_ptr + 1) = backup_ram_save_area_start2[power_of_two_index + 3];
        *(byte *)((int)tag_ptr + 2) = backup_ram_save_area_start2[power_of_two_index + 5];
        *(byte *)((int)tag_ptr + 3) = backup_ram_save_area_start2[power_of_two_index + 7];
        if (read_offset2 == tag) {
          j = k + 1;
          *(short *)((int)sat_blocks + k * 2 + total_blocks_divided_8) = (short)read_offset2_high;
          if (j < blocks_needed_) {
            backup_ram_save_area_start2 =
                 (byte *)((read_offset2_high >> 3) + (int)(*im2)->sat_blocks);
            *backup_ram_save_area_start2 =
                 *backup_ram_save_area_start2 | powers_of_two[read_offset2_high & 7];
          }
          else {
            read_offset2_high = (*im2)->totalBlocks;
          }
        }
      }
      k = j;
    }
  }
  for (k = 0; k < blocks_needed_ - 1; k = k + 1) {
    puVar3 = (ushort *)((int)sat_blocks + k * 2 + total_blocks_divided_8);
    read_offset2 = k;
    while (read_offset2 = read_offset2 + 1, read_offset2 < blocks_needed_) {
      if (*(ushort *)((int)sat_blocks + read_offset2 * 2 + total_blocks_divided_8) < *puVar3) {
        uVar1 = *puVar3;
        puVar2 = (ushort *)((int)sat_blocks + read_offset2 * 2 + total_blocks_divided_8);
        *puVar3 = *puVar2;
        *puVar2 = uVar1;
      }
    }
  }
                    /* Copy found free blocks to sat_blocks list?? */
  k = 0;
  if (blocks_needed_ != 0) {
    do {
      read_offset2 = k + 1;
      (*im2)->sat_blocks[k] = *(short *)((int)sat_blocks + k * 2 + total_blocks_divided_8);
      k = read_offset2;
    } while (read_offset2 < blocks_needed_);
  }
  (*im2)->sat_blocks[blocks_needed_] = 0;
  return 0;
}


undefined4 mark_bad_blocks___(void)

{
  undefined *puVar1;
  int iVar2;
  int iVar3;
  byte *extraout_r3;
  uint uVar4;
  undefined4 unaff_r10;
  int *piVar5;
  byte abStack_20 [12];
  
  puVar1 = PTR_PTR_SetOnChipReg__060273b8;
  piVar5 = (int *)(PTR_PTR_SetOnChipReg__060273b8 + 0x14);
  setupPowersOf2Struct(abStack_20);
  iVar3 = *(int *)(*piVar5 + 0x30) + *(int *)(*piVar5 + 0x40);
  for (uVar4 = 0; uVar4 < *(uint *)(*piVar5 + 0x38) >> 3; uVar4 = uVar4 + 1) {
    *(undefined *)(*(int *)(*piVar5 + 0x2c) + uVar4) = *(undefined *)(uVar4 * 2 + iVar3 + 1);
  }
  iVar2 = (*(code *)(PTR_LAB_060273bc + 0x6027348))();
  *extraout_r3 = *extraout_r3 | abStack_20[iVar2];
  if (*(int *)(*piVar5 + 0x34) == 1) {
    unaff_r10 = *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_060273c0;
    (**(code **)puVar1)(0xffffffff);
  }
  for (uVar4 = 0; uVar4 < *(uint *)(*piVar5 + 0x3c); uVar4 = uVar4 + 1) {
    if (uVar4 < *(uint *)(*piVar5 + 0x38) >> 3) {
      *(undefined *)(uVar4 * 2 + iVar3 + 1) = *(undefined *)(*(int *)(*piVar5 + 0x2c) + uVar4);
    }
    else {
      *(undefined *)(uVar4 * 2 + iVar3 + 1) = 0;
    }
  }
  if (*(int *)(*piVar5 + 0x34) == 1) {
    (*(code *)(PTR_DAT_060273c4 + 0x60273b2))();
  }
  uVar4 = 0;
  while( true ) {
    if (*(uint *)(*piVar5 + 0x38) >> 3 <= uVar4) {
      if (*(int *)(*piVar5 + 0x34) == 1) {
        (**(code **)puVar1)(unaff_r10);
      }
      return 0;
    }
    if (*(char *)(uVar4 * 2 + iVar3 + 1) != *(char *)(*(int *)(*piVar5 + 0x2c) + uVar4)) break;
    uVar4 = uVar4 + 1;
  }
  if (*(int *)(*piVar5 + 0x34) == 1) {
    (**(code **)puVar1)(unaff_r10);
  }
  return 8;
}


void setupPowersOf2Struct(byte *powers)

{
  *powers = (byte)WORD_06026828;
  powers[1] = 0x40;
  powers[2] = 0x20;
  powers[3] = 0x10;
  powers[4] = 8;
  powers[5] = 4;
  powers[6] = 2;
  powers[7] = 1;
  return;
}


void setup_days_by_month(dword *months)

{
  *months = 31;
  months[1] = 59;
  months[2] = 90;
  months[3] = 120;
  months[4] = 151;
  months[5] = 181;
  months[6] = 212;
  months[7] = 243;
  months[8] = 273;
  months[9] = 304;
  months[10] = 334;
  return;
}


/* WARNING: Unknown calling convention */

uint software_divide_(int divisor,int dividend)

{
  char cVar1;
  bool bVar2;
  bool bVar3;
  bool bVar4;
  byte bVar5;
  uint uVar6;
  uint in_r1;
  uint uVar7;
  uint uVar9;
  uint uVar11;
  uint uVar12;
  uint uVar13;
  uint uVar14;
  uint uVar15;
  uint uVar16;
  uint uVar17;
  uint uVar18;
  uint uVar19;
  uint uVar20;
  uint uVar21;
  uint uVar22;
  uint uVar23;
  uint uVar24;
  uint uVar25;
  uint uVar26;
  uint uVar27;
  uint uVar28;
  uint uVar29;
  uint uVar30;
  uint uVar31;
  uint uVar32;
  uint uVar33;
  uint uVar34;
  uint uVar35;
  uint uVar36;
  uint uVar37;
  uint uVar38;
  uint uVar39;
  uint uVar40;
  uint uVar8;
  uint uVar10;
  
  if (divisor != 0) {
    uVar7 = (uint)((in_r1 & 0x80000000) != 0);
    uVar8 = uVar7 - divisor;
    bVar4 = uVar8 <= uVar7;
    uVar12 = in_r1 << 2;
    bVar3 = (uVar8 & 0x80000000) == 0;
    uVar7 = uVar8 * 2 | (uint)((in_r1 & 0x40000000) != 0);
    uVar8 = (uint)bVar4 * (uVar7 - divisor) + (uint)!bVar4 * (uVar7 + divisor);
    cVar1 = bVar4 * (uVar7 < uVar8) + !bVar4 * (uVar8 < uVar7);
    bVar5 = bVar3 * cVar1 + (!bVar3 && cVar1 == '\0');
    uVar7 = (uint)bVar5 << 8;
    uVar9 = uVar8 * 2 | (uint)((uVar12 & 0x80000000) != 0);
    bVar3 = (bVar5 & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar8 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar9 - divisor) + (uint)!bVar3 * (uVar9 + divisor);
    cVar1 = bVar3 * (uVar9 < uVar10) + !bVar3 * (uVar10 < uVar9);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar13 = uVar7 & 0xfffffeff | uVar8;
    uVar6 = uVar7 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x40000000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar14 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x20000000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar15 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x10000000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar16 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x8000000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar17 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x4000000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar18 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x2000000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar19 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x1000000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar20 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x800000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar21 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x400000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar22 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x200000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar23 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x100000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar24 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x80000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar25 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x40000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar26 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x20000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar27 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x10000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar28 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x8000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar29 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x4000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar30 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x2000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar31 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x1000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar32 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x800) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar33 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x400) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar34 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x200) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar35 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x100) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar36 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x80) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar37 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x40) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar38 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x20) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar39 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x10) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar40 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 8) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar11 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar12 = uVar10 * 2 | (uint)((uVar12 & 4) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar9 = (uint)bVar3 * (uVar12 - divisor) + (uint)!bVar3 * (uVar12 + divisor);
    cVar1 = bVar3 * (uVar12 < uVar9) + !bVar3 * (uVar9 < uVar12);
    uVar8 = uVar6 | uVar8 & 0xfffffeff |
            (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    return (((((((((((((((((((((((((((((((uint)bVar4 << 1 |
                                        (uint)((bVar5 & 1) == ((byte)(uVar7 >> 9) & 1))) << 1 |
                                       (uint)(((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1)
                                             )) << 1 |
                                      (uint)(((byte)(uVar14 >> 8) & 1) == ((byte)(uVar14 >> 9) & 1))
                                      ) << 1 | (uint)(((byte)(uVar15 >> 8) & 1) ==
                                                     ((byte)(uVar15 >> 9) & 1))) << 1 |
                                    (uint)(((byte)(uVar16 >> 8) & 1) == ((byte)(uVar16 >> 9) & 1)))
                                    << 1 | (uint)(((byte)(uVar17 >> 8) & 1) ==
                                                 ((byte)(uVar17 >> 9) & 1))) << 1 |
                                  (uint)(((byte)(uVar18 >> 8) & 1) == ((byte)(uVar18 >> 9) & 1))) <<
                                  1 | (uint)(((byte)(uVar19 >> 8) & 1) == ((byte)(uVar19 >> 9) & 1))
                                 ) << 1 | (uint)(((byte)(uVar20 >> 8) & 1) ==
                                                ((byte)(uVar20 >> 9) & 1))) << 1 |
                               (uint)(((byte)(uVar21 >> 8) & 1) == ((byte)(uVar21 >> 9) & 1))) << 1
                              | (uint)(((byte)(uVar22 >> 8) & 1) == ((byte)(uVar22 >> 9) & 1))) << 1
                             | (uint)(((byte)(uVar23 >> 8) & 1) == ((byte)(uVar23 >> 9) & 1))) << 1
                            | (uint)(((byte)(uVar24 >> 8) & 1) == ((byte)(uVar24 >> 9) & 1))) << 1 |
                           (uint)(((byte)(uVar25 >> 8) & 1) == ((byte)(uVar25 >> 9) & 1))) << 1 |
                          (uint)(((byte)(uVar26 >> 8) & 1) == ((byte)(uVar26 >> 9) & 1))) << 1 |
                         (uint)(((byte)(uVar27 >> 8) & 1) == ((byte)(uVar27 >> 9) & 1))) << 1 |
                        (uint)(((byte)(uVar28 >> 8) & 1) == ((byte)(uVar28 >> 9) & 1))) << 1 |
                       (uint)(((byte)(uVar29 >> 8) & 1) == ((byte)(uVar29 >> 9) & 1))) << 1 |
                      (uint)(((byte)(uVar30 >> 8) & 1) == ((byte)(uVar30 >> 9) & 1))) << 1 |
                     (uint)(((byte)(uVar31 >> 8) & 1) == ((byte)(uVar31 >> 9) & 1))) << 1 |
                    (uint)(((byte)(uVar32 >> 8) & 1) == ((byte)(uVar32 >> 9) & 1))) << 1 |
                   (uint)(((byte)(uVar33 >> 8) & 1) == ((byte)(uVar33 >> 9) & 1))) << 1 |
                  (uint)(((byte)(uVar34 >> 8) & 1) == ((byte)(uVar34 >> 9) & 1))) << 1 |
                 (uint)(((byte)(uVar35 >> 8) & 1) == ((byte)(uVar35 >> 9) & 1))) << 1 |
                (uint)(((byte)(uVar36 >> 8) & 1) == ((byte)(uVar36 >> 9) & 1))) << 1 |
               (uint)(((byte)(uVar37 >> 8) & 1) == ((byte)(uVar37 >> 9) & 1))) << 1 |
              (uint)(((byte)(uVar38 >> 8) & 1) == ((byte)(uVar38 >> 9) & 1))) << 1 |
             (uint)(((byte)(uVar39 >> 8) & 1) == ((byte)(uVar39 >> 9) & 1))) << 1 |
            (uint)(((byte)(uVar40 >> 8) & 1) == ((byte)(uVar40 >> 9) & 1))) << 1 |
           (uint)(((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1))) << 1 |
           (uint)(((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1));
  }
  *(undefined4 *)PTR_DAT_06029ad0 = DAT_06029ad4;
  return 0;
}


longlong software_modulo_(void)

{
  char cVar1;
  bool bVar2;
  bool bVar3;
  bool bVar4;
  byte bVar5;
  uint uVar6;
  undefined *puVar7;
  int in_r0;
  uint in_r1;
  uint uVar8;
  uint uVar10;
  uint uVar12;
  uint uVar13;
  uint uVar14;
  uint uVar15;
  uint uVar16;
  uint uVar17;
  uint uVar18;
  uint uVar19;
  uint uVar20;
  uint uVar21;
  uint uVar22;
  uint uVar23;
  uint uVar24;
  uint uVar25;
  uint uVar26;
  uint uVar27;
  uint uVar28;
  uint uVar29;
  uint uVar30;
  uint uVar31;
  uint uVar32;
  uint uVar33;
  uint uVar34;
  uint uVar35;
  uint uVar36;
  uint uVar37;
  uint uVar38;
  uint uVar39;
  uint uVar40;
  uint uVar41;
  uint uVar9;
  uint uVar11;
  
  puVar7 = PTR_DAT_06029c50;
  if (in_r0 == 0) {
    *(undefined4 *)PTR_DAT_06029c50 = DAT_06029c54;
    return ZEXT48(puVar7) << 0x20;
  }
  uVar8 = (uint)((in_r1 & 0x80000000) != 0);
  uVar9 = uVar8 - in_r0;
  bVar4 = uVar9 <= uVar8;
  uVar13 = in_r1 << 2;
  bVar3 = (uVar9 & 0x80000000) == 0;
  uVar8 = uVar9 * 2 | (uint)((in_r1 & 0x40000000) != 0);
  uVar9 = (uint)bVar4 * (uVar8 - in_r0) + (uint)!bVar4 * (uVar8 + in_r0);
  cVar1 = bVar4 * (uVar8 < uVar9) + !bVar4 * (uVar9 < uVar8);
  bVar5 = bVar3 * cVar1 + (!bVar3 && cVar1 == '\0');
  uVar8 = (uint)bVar5 << 8;
  uVar10 = uVar9 * 2 | (uint)((uVar13 & 0x80000000) != 0);
  bVar3 = (bVar5 & 1) == ((byte)(uVar8 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar9 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar10 - in_r0) + (uint)!bVar3 * (uVar10 + in_r0);
  cVar1 = bVar3 * (uVar10 < uVar11) + !bVar3 * (uVar11 < uVar10);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar14 = uVar8 & 0xfffffeff | uVar9;
  uVar6 = uVar8 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x40000000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar15 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x20000000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar16 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x10000000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar17 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x8000000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar18 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x4000000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar19 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x2000000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar20 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x1000000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar21 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x800000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar22 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x400000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar23 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x200000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar24 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x100000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar25 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x80000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar26 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x40000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar27 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x20000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar28 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x10000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar29 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x8000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar30 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x4000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar31 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x2000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar32 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x1000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar33 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x800) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar34 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x400) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar35 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x200) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar36 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x100) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar37 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x80) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar38 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x40) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar39 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x20) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar40 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x10) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar41 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 8) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar12 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar8 = ((((((((((((((((((((((((((((((uint)bVar4 << 1 |
                                      (uint)((bVar5 & 1) == ((byte)(uVar8 >> 9) & 1))) << 1 |
                                     (uint)(((byte)(uVar14 >> 8) & 1) == ((byte)(uVar14 >> 9) & 1)))
                                     << 1 | (uint)(((byte)(uVar15 >> 8) & 1) ==
                                                  ((byte)(uVar15 >> 9) & 1))) << 1 |
                                   (uint)(((byte)(uVar16 >> 8) & 1) == ((byte)(uVar16 >> 9) & 1)))
                                   << 1 | (uint)(((byte)(uVar17 >> 8) & 1) ==
                                                ((byte)(uVar17 >> 9) & 1))) << 1 |
                                 (uint)(((byte)(uVar18 >> 8) & 1) == ((byte)(uVar18 >> 9) & 1))) <<
                                 1 | (uint)(((byte)(uVar19 >> 8) & 1) == ((byte)(uVar19 >> 9) & 1)))
                                << 1 | (uint)(((byte)(uVar20 >> 8) & 1) == ((byte)(uVar20 >> 9) & 1)
                                             )) << 1 |
                              (uint)(((byte)(uVar21 >> 8) & 1) == ((byte)(uVar21 >> 9) & 1))) << 1 |
                             (uint)(((byte)(uVar22 >> 8) & 1) == ((byte)(uVar22 >> 9) & 1))) << 1 |
                            (uint)(((byte)(uVar23 >> 8) & 1) == ((byte)(uVar23 >> 9) & 1))) << 1 |
                           (uint)(((byte)(uVar24 >> 8) & 1) == ((byte)(uVar24 >> 9) & 1))) << 1 |
                          (uint)(((byte)(uVar25 >> 8) & 1) == ((byte)(uVar25 >> 9) & 1))) << 1 |
                         (uint)(((byte)(uVar26 >> 8) & 1) == ((byte)(uVar26 >> 9) & 1))) << 1 |
                        (uint)(((byte)(uVar27 >> 8) & 1) == ((byte)(uVar27 >> 9) & 1))) << 1 |
                       (uint)(((byte)(uVar28 >> 8) & 1) == ((byte)(uVar28 >> 9) & 1))) << 1 |
                      (uint)(((byte)(uVar29 >> 8) & 1) == ((byte)(uVar29 >> 9) & 1))) << 1 |
                     (uint)(((byte)(uVar30 >> 8) & 1) == ((byte)(uVar30 >> 9) & 1))) << 1 |
                    (uint)(((byte)(uVar31 >> 8) & 1) == ((byte)(uVar31 >> 9) & 1))) << 1 |
                   (uint)(((byte)(uVar32 >> 8) & 1) == ((byte)(uVar32 >> 9) & 1))) << 1 |
                  (uint)(((byte)(uVar33 >> 8) & 1) == ((byte)(uVar33 >> 9) & 1))) << 1 |
                 (uint)(((byte)(uVar34 >> 8) & 1) == ((byte)(uVar34 >> 9) & 1))) << 1 |
                (uint)(((byte)(uVar35 >> 8) & 1) == ((byte)(uVar35 >> 9) & 1))) << 1 |
               (uint)(((byte)(uVar36 >> 8) & 1) == ((byte)(uVar36 >> 9) & 1))) << 1 |
              (uint)(((byte)(uVar37 >> 8) & 1) == ((byte)(uVar37 >> 9) & 1))) << 1 |
             (uint)(((byte)(uVar38 >> 8) & 1) == ((byte)(uVar38 >> 9) & 1))) << 1 |
            (uint)(((byte)(uVar39 >> 8) & 1) == ((byte)(uVar39 >> 9) & 1))) << 1 |
           (uint)(((byte)(uVar40 >> 8) & 1) == ((byte)(uVar40 >> 9) & 1))) << 1 |
          (uint)(((byte)(uVar41 >> 8) & 1) == ((byte)(uVar41 >> 9) & 1))) << 1 |
          (uint)(((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1));
  uVar13 = uVar11 * 2 | (uint)((uVar13 & 4) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar10 = (uint)bVar3 * (uVar13 - in_r0) + (uint)!bVar3 * (uVar13 + in_r0);
  cVar1 = bVar3 * (uVar13 < uVar10) + !bVar3 * (uVar10 < uVar13);
  uVar9 = uVar6 | uVar9 & 0xfffffeff | (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  if (((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1)) {
    return CONCAT44(uVar8,uVar10);
  }
  return CONCAT44(uVar8,in_r0 + uVar10);
}

