typedef enum BUP_ERROR {
    BUP_SUCCESS=0,
    BUP_NOT_CONNECTED=1,
    BUP_NOT_FORMATTED=2,
    BUP_WRITE_PROTECTED=3,
    BUP_NOT_ENOUGH_SPACE=4,
    BUP_NOT_FOUND=5,
    BUP_FOUND=6,
    BUP_NO_MATCH=7,
    BUP_BROKEN=8
} BUP_ERROR;

typedef enum BACKUP_DEVICE {
    DEVICE_INTERNAL=0,
    DEVICE_CARTRIDGE=1,
    DEVICE_SERIAL=2
} BACKUP_DEVICE;

typedef enum BACKUP_OVERWRITE_MODE {
    OVERWRITE_OFF=0,
    OVERWRITE_ON=1
} BACKUP_OVERWRITE_MODE;

typedef enum SEARCH_MODE {
    DEFAULT=0,
    SAVE_SEARCH=1,
    RESUME_SEARCH=2
} SEARCH_MODE;

typedef unsigned char   undefined;
typedef unsigned char    byte;
typedef unsigned int    dword;
typedef long long    longlong;
typedef unsigned char    uchar;
typedef unsigned int    uint;
typedef unsigned char    undefined1;
typedef unsigned short    undefined2;
typedef unsigned int    undefined4;
typedef unsigned long long    undefined8;
typedef unsigned short    ushort;
typedef unsigned short    word;
typedef struct INTERNAL_METADATA INTERNAL_METADATA, *PINTERNAL_METADATA;

struct INTERNAL_METADATA {
    pointer function_pointers[11];
    short * sat_blocks; /* Created by retype action */
    byte * backup_ram_start;
    dword cart_format_flag?;
    dword totalBlocks;
    dword blockSize;
    dword blockSize_in_bytes;
    dword offset_of_filedata_in_blocks;
    undefined1 bad_block; /* Created by retype action */
    undefined field9_0x49;
    undefined field10_0x4a;
    undefined field11_0x4b;
    dword backup_ram_bad_blocks_bitmap;
    dword last_found_block_search; /* Created by retype action */
    byte internal_connected;
    byte cartridge_connected;
    byte serial_connected;
    undefined field17_0x57;
    dword totalBlocks_cart;
    dword blockSize_cart;
    dword cartridge_offset_to_data_in_blocks;
    dword cartridge_flag_2;
    dword something_serial?;
    dword serial_int_mask??; /* Created by retype action */
    undefined field24_0x70;
    undefined field25_0x71;
    undefined field26_0x72;
    undefined field27_0x73;
    byte serial_partition_number;
    undefined field29_0x75;
    undefined field30_0x76;
    undefined field31_0x77;
};

typedef struct backup_config backup_config, *Pbackup_config;

struct backup_config {
    word unit_id;
    word partition;
};

typedef struct backup_stat backup_stat, *Pbackup_stat;

struct backup_stat {
    dword totalsize;
    dword totalblock;
    dword blocksize;
    dword freesize;
    dword freeblock;
    dword datanum;
};

typedef struct backup_file backup_file, *Pbackup_file;

struct backup_file {
    byte filename[12];
    byte comment[11];
    byte language;
    dword date;
    dword datasize;
    dword blocksize;
};

typedef struct backup_date backup_date, *Pbackup_date;

struct backup_date {
    byte year;
    byte month;
    byte day;
    byte time;
    byte min;
    byte week;
};
